"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.coerceEnumValues = void 0;
/**
 * @module node-opcua-address-space
 */
const node_opcua_assert_1 = require("node-opcua-assert");
const node_opcua_data_model_1 = require("node-opcua-data-model");
const node_opcua_types_1 = require("node-opcua-types");
function coerceEnumValues(enumValues) {
    if (Array.isArray(enumValues)) {
        //
        return enumValues.map((en) => {
            node_opcua_assert_1.assert(en.hasOwnProperty("value"));
            node_opcua_assert_1.assert(en.hasOwnProperty("displayName"));
            return new node_opcua_types_1.EnumValueType({
                displayName: node_opcua_data_model_1.coerceLocalizedText(en.displayName),
                value: en.value
            });
        });
    }
    else {
        return coerceEnumValues(Object.entries(enumValues).map((entrie) => {
            const [key, value] = entrie;
            return new node_opcua_types_1.EnumValueType({
                description: node_opcua_data_model_1.coerceLocalizedText(key),
                displayName: node_opcua_data_model_1.coerceLocalizedText(key),
                value
            });
        }));
    }
}
exports.coerceEnumValues = coerceEnumValues;
//# sourceMappingURL=coerce_enum_value.js.map