"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAddressSpace = exports.readNodeSet2XmlFile = void 0;
const fs = require("fs");
const node_opcua_debug_1 = require("node-opcua-debug");
const source_1 = require("../dist/source");
const doDebug = node_opcua_debug_1.checkDebugFlag(__filename);
const debugLog = node_opcua_debug_1.make_debugLog(__filename);
function readNodeSet2XmlFile(xmlFile, callback) {
    // istanbul ignore next
    if (!fs.existsSync(xmlFile)) {
        return callback(new Error("generateAddressSpace : cannot file nodeset2 xml file at " + xmlFile));
    }
    debugLog(" parsing ", xmlFile);
    fs.readFile(xmlFile, "ascii", (err, xmlData) => {
        callback(err, xmlData);
    });
}
exports.readNodeSet2XmlFile = readNodeSet2XmlFile;
function generateAddressSpace(addressSpace, xmlFiles, callback) {
    source_1.generateAddressSpaceRawCallback(addressSpace, xmlFiles, readNodeSet2XmlFile, callback);
}
exports.generateAddressSpace = generateAddressSpace;
// tslint:disable:no-var-requires
// tslint:disable:max-line-length
const thenify = require("thenify");
module.exports.generateAddressSpace = thenify.withCallback(module.exports.generateAddressSpace);
//# sourceMappingURL=generate_address_space.js.map